%-------------------------------------------------------%
% Lab IMP03 Part 3
% Median filter
%-------------------------------------------------------%
% Open and display image file
%-------------------------------------------------------%
p = imread('keypad.tif');
figure(1)
clf
imagesc(p);
set(gca,'dataaspectratio',[1 1 1])
colormap(gray)
title('Original image')
%-------------------------------------------------------%
% Image degradation by adding noise
%-------------------------------------------------------%
pn = imnoise(p,'salt & pepper',0.2);
figure(2)
imagesc(pn)
set(gca,'dataaspectratio',[1 1 1])
colormap(gray)
title('Degraded image by salt & pepper noise')
%-------------------------------------------------------%
% add your own code to perform median filtering
%-------------------------------------------------------%
[N,M] = size(pn)
w = 1 %w = 1 for window size 3x3, w = 2 for window size 5x5
for i = 1:N
    for j = 1:M
        a = i-w;
        b = i+w;
        c = j-w;
        d = j+w;
        % write commands so that parameters a,b,c,d are in
        % these ranges: a >= 1, b<=N, c>=1, d<=M
        
        % moving window ==> crop an image into subimage
        subp = pn(a:b,c:d);
        
        % reshape subimage into 1-dimension array
        subp = double(reshape(subp,[1 prod(size(subp))]));
        
        %Compute median of subp and assign the value to pout(i,j)
        
    end
end
figure(3)
imagesc(pout)
set(gca,'dataaspectratio',[1 1 1])
colormap(gray)
title('Restored image by the median filter')
      